/**
 * 
 */
package org.geekfu.OldCartographer;

import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.MouseEvent;

import javax.swing.JComponent;
import javax.swing.event.MouseInputListener;

public class CellComponent extends JComponent implements MouseInputListener{
	MapCell cell;int x,y;
	Map map;
	//MapCell mark;
	MapLayoutConstraints constraints;

	public CellComponent(Map map,MapCell cell,int x,int y) {
		this.map=map;
		//mark=null;

		setDoubleBuffered(true);
		setPreferredSize(map.getCellsize());
		this.x=x;this.y=y;

		addMouseListener(this);
		addMouseMotionListener(this);
		setCell(cell);
	}

	public void setCell(MapCell cell) {
		this.cell=cell;
		if(cell instanceof LocationAware)
		{
			LocationAware la=(LocationAware)cell;
			la.setX(x);la.setY(y);
			la.setComponent(this);
		}
	}

	public void paintComponent(Graphics g) {
		cell.paintComponent(g);
	}

	public void setPosition() {
		Point loc=new Point(constraints.getPoint().x*map.getCellsize().width+constraints.getOffset().x,
				constraints.getPoint().y*map.getCellsize().height+constraints.getOffset().y);

		setBounds(loc.x,loc.y,map.getCellsize().width,map.getCellsize().height);
		x=constraints.getPoint().x;
		y=constraints.getPoint().y;
	}

	private void handleMouseEvent(String eventtype,MouseEvent event) {
		Class[] argtypes={int.class,int.class,int.class};
		Object[] args={new Integer(x),new Integer(y),new Integer(event.getButton())};

		try {
			cell.getClass().getMethod(eventtype,argtypes).invoke(cell,args);
		} catch (Exception exc) {} // I don't care if they didn't implement it.

		if(map.isFocusable() && // Tell the map it should take kbd focus, if it can, and if it's a click
				(eventtype.equals("mouseClicked") || 
						eventtype.equals("mouseReleased") ||
						eventtype.equals("mouseDragged") ||
						eventtype.equals("mousePressed")))
			map.requestFocus();
	}

	public void mouseClicked(MouseEvent arg0) {
		handleMouseEvent("mouseClicked",arg0);
	}

	public void mouseReleased(MouseEvent arg0) {
		handleMouseEvent("mouseReleased",arg0);
	}

	public void mouseExited(MouseEvent arg0) {
		handleMouseEvent("mouseExited",arg0);
	}
	public void mouseDragged(MouseEvent arg0) {
		handleMouseEvent("mouseDragged",arg0);
	}
	public void mouseMoved(MouseEvent arg0) {
		handleMouseEvent("mouseMoved",arg0);
	}

	public void mousePressed(MouseEvent arg0) {
		handleMouseEvent("mousePressed",arg0);
	}

	public void mouseEntered(MouseEvent arg0) {
		handleMouseEvent("mouseEntered",arg0);
	}

	public MapLayoutConstraints getConstraints() {
		return constraints;
	}

	public void setConstraints(MapLayoutConstraints constraints) {
		this.constraints = constraints;
	}

	public MapCell getCell() {
		return cell;
	}

	public int getMapX(){
		return x;
	}
	public int getMapY(){
		return y;
	}
}