package org.geekfu.hippo;

import javax.swing.JFrame;

import org.geekfu.MapPanel.MapPanel;
import org.mozilla.javascript.ScriptableObject;

public class HostGameWindow extends ScriptableObject {
	private JFrame window;
	private MapPanel mapPanel;
	private HostMap hostMap;
	
	public HostGameWindow(){}
	
	public synchronized void jsConstructor(){
		window=new JFrame("Hippo!");
		mapPanel=new MapPanel(null,null,true);
		window.setSize(830,640);
		window.getContentPane().add(mapPanel);
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		window.setVisible(true);
		mapPanel.getTextEntry().requestFocus();
		mapPanel.addActionListener(new TextListener(this));
		
		defineProperty("map",this.getClass(),ScriptableObject.PERMANENT);
		defineProperty("sidebar",this.getClass(),ScriptableObject.PERMANENT);
		defineProperty("textVisible",this.getClass(),ScriptableObject.PERMANENT);
		defineFunctionProperties(new String[]{"setSize","print"}, this.getClass(), ScriptableObject.PERMANENT);
	}
	
	@Override
	public String getClassName() {
		return "GameWindow";
	}

	public HostMap getMap(){
		return hostMap;
	}
	public void setMap(Object map){
		if(map!=null && map instanceof HostMap){
			hostMap=(HostMap) map;
			mapPanel.setMap(hostMap.getMap());
		}else{
			mapPanel.setMap(null);
		}
	}
	
	public HostSidebar getSidebar(){
		return null;
	}
	public void setSidebar(Object sidebar){} // expects HostSidebar
	
	public boolean getTextVisible(){
		return mapPanel.isText();
	}
	public void setTextVisible(boolean text){
		mapPanel.setText(text);
		
	}
	
	public void setSize(int width,int height){
		window.setSize(width,height);
	}

	public void print(Object obj){
		mapPanel.showString(obj.toString());
	}
	
	public MapPanel getMapPanel() {
		return mapPanel;
	}
}
