package org.geekfu.hippo;

import org.geekfu.MapPanel.MapPanel;
import org.geekfu.MapPanel.MapPanelListener;
import org.mozilla.javascript.Context;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.Undefined;

public class TextListener implements MapPanelListener{
	private Scriptable scope;
	private MapPanel mapPanel;
	
	public TextListener(HostGameWindow parent){
		this.scope=parent.getParentScope();
		this.mapPanel=parent.getMapPanel();
	}
	
	public void textEntered(String str) {

		mapPanel.showString("<< "+str);

		try{
			Context ctx=Context.enter();
			Object res=ctx.evaluateString(scope, str, "", 1, null);
			if(res instanceof Undefined || res==null)res="undefined";
			mapPanel.showString(">> "+res.toString());
		}catch(Exception err){
		 	mapPanel.showString(">>!! "+err.getMessage());
		 	err.printStackTrace();
		}
	}

}
